﻿using Adaptation.Shared;
using Adaptation.Shared.Properties;
using System;
using System.Collections.Generic;
using System.Linq;

namespace Adaptation.FileHandlers.MET08THFTIRQS408M
{

    public class WSRequest
    {
        public bool SentToMetrology { get; set; }
        public bool SentToSPC { get; set; }
        //
        public long Id { get; set; }
        public string Batch { get; set; }
        public string Cassette { get; set; }
        public string CellName { get; set; }
        public string Date { get; set; }
        public string FilePath { get; set; }
        public string Layer { get; set; }
        public string MeanThickness { get; set; }
        public string Op { get; set; }
        public string PSN { get; set; }
        public string PassFail { get; set; }
        public string RDS { get; set; }
        public string RVThickness { get; set; }
        public string Reactor { get; set; }
        public string Recipe { get; set; }
        public string StdDev { get; set; }
        public string Title { get; set; }
        public string UniqueId { get; set; }
        public string Wafer { get; set; }
        public string Zone { get; set; }
        public List<QS408M.Detail> Details { get; protected set; }

        [Obsolete("For json")] public WSRequest() { }

        internal WSRequest(IFileRead fileRead, Logistics logistics, List<QS408M.Description> descriptions)
        {
            Id = 0;
            FilePath = string.Empty;
            if (fileRead is null)
            { }
            CellName = logistics.MesEntity;
            if (descriptions[0] is not QS408M.Description x)
                throw new Exception();
            Details = new List<QS408M.Detail>();
            //Header
            {
                Batch = x.Lot;
                Cassette = x.Cassette;
                Date = x.Date;
                Op = x.Employee;
                Layer = x.Layer;
                MeanThickness = x.MeanThickness;
                PSN = x.PSN;
                PassFail = x.PassFail;
                RDS = x.RDS;
                RVThickness = x.RVThickness;
                Reactor = x.Reactor;
                Recipe = x.Recipe;
                StdDev = x.StdDev;
                Title = x.Title;
                UniqueId = x.UniqueId;
                Wafer = x.Wafer;
                Zone = x.Zone;
            }
            QS408M.Detail detail;
            foreach (QS408M.Description description in descriptions)
            {
                detail = new QS408M.Detail
                {
                    HeaderUniqueId = description.HeaderUniqueId,
                    Position = description.Position,
                    Thickness = description.Thickness,
                    UniqueId = description.UniqueId
                };
                Details.Add(detail);
            }
            if (Date is null)
                Date = logistics.DateTimeFromSequence.ToString();
            if (UniqueId is null && Details.Any())
                UniqueId = Details[0].HeaderUniqueId;
        }

    }

}